//------------------------------------------------------------------------------

datablock AudioProfile(VehicleAppearSound)
{
   filename    = "fx/vehicles/inventory_pad_appear.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ActivateVehiclePadSound)
{
   filename = 	"fx/powered/vehicle_pad_on.wav";
   description = AudioClose3d;
   preload = true;
};

datablock StationFXVehicleData( VehicleInvFX )
{
   lifetime = 6.0;

   glowTopHeight = 1.5;
   glowBottomHeight = 0.1;
   glowTopRadius = 12.5;
   glowBottomRadius = 12.0;
   numGlowSegments = 26;
   glowFadeTime = 3.25;
   
   armLightDelay = 2.3;
   armLightLifetime = 3.0;
   armLightFadeTime = 1.5;
   numArcSegments = 10.0;

   sphereColor = "0.1 0.1 0.5";
   spherePhiSegments = 13;
   sphereThetaSegments = 8;
   sphereRadius = 12.0;
   sphereScale = "1.05 1.05 0.85";
   
   glowNodeName = "GLOWFX";

   leftNodeName[0]   = "LFX1";
   leftNodeName[1]   = "LFX2";
   leftNodeName[2]   = "LFX3";
   leftNodeName[3]   = "LFX4";

   rightNodeName[0]  = "RFX1";
   rightNodeName[1]  = "RFX2";
   rightNodeName[2]  = "RFX3";
   rightNodeName[3]  = "RFX4";


   texture[0] = "special/stationGlow";
   texture[1] = "special/stationLight2";
};

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
function vpadtimeout(%client)
{
	%client.vpadtimeout = 0;
}

function serverCmdBuyVehicle(%client, %blockName)
{
	if(%client.vpadtimeout)
		return;
	%client.vpadtimeout = 1;
	schedule(500, 0, vpadtimeout, %client);

	missionarea.flightceiling = 450;			//v2 mod
	missionarea.flightceilingrange = 1;		//v2
   %team = %client.getSensorGroup();
   if(vehicleCheck(%blockName, %team) || (%blockname $= "EasterEgg" && $testcheats) && !$host::tournamentmode)        
   {
      %station = %client.player.station.pad;
      if( (%station.ready) && (%station.station.vehicle[%blockName]) || (%blockname $= "EasterEgg" && $testcheats) && !$host::tournamentmode)
      {
         %trans = %station.getTransform();
         %pos = getWords(%trans, 0, 2);
         %matrix = VectorOrthoBasis(getWords(%trans, 3, 6));
         %yrot = getWords(%matrix, 3, 5);
         %p = vectorAdd(%pos,vectorScale(%yrot, -3));
         %p =  getWords(%p,0, 1) @ " " @ getWord(%p,2) + 4;
         %p = vectorAdd(%p, %blockName.spawnOffset);
         %rot = getWords(%trans, 3, 5);
         %angle = getWord(%trans, 6) + 3.14;
         %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | 
                 $TypeMasks::StationObjectType | $TypeMasks::TurretObjectType;
	      InitContainerRadiusSearch(%p, %blockName.checkRadius, %mask);
   
	      %clear = 1;
         for (%x = 0; (%obj = containerSearchNext()) != 0; %x++) 
         {
            if((%obj.getType() & $TypeMasks::VehicleObjectType) && (%obj.getDataBlock().checkIfPlayersMounted(%obj)))
            {
               %clear = 0;
               break;
            }
            else
               %removeObjects[%x] = %obj;
         }
         if(%clear)
         {
            %fadeTime = 0;
            for(%i = 0; %i < %x; %i++)
            {
               if(%removeObjects[%i].getType() & $TypeMasks::PlayerObjectType)
               {
                  %pData = %removeObjects[%i].getDataBlock();
                  %pData.damageObject(%removeObjects[%i], 0, "0 0 0", 1000, $DamageType::VehicleSpawn);
               }
               else
               {
                  %removeObjects[%i].mountable = 0;
                  %removeObjects[%i].startFade( 700, 0, true );		//v2 mod, was 1000
                  if(%removeobjects[%i].turretobject)
	                  %removeObjects[%i].turretobject.startFade( 700, 0, true );		//v2 mod added to sync fade of turrets
                  %removeObjects[%i].schedule(701, "delete");			//v2 mod, was 1001
                  %fadeTime = 750;												//v2 mod, was 1500
               }
            }
				if(%blockname $= "EasterEgg")
					{
					}
				else
					{
					%station.deploynow = %deployNow;		//v2h
	            schedule(%fadeTime, 0, "createVehicle", %client, %station, %blockName, %team , %p, %rot, %angle);
         		}
			}
         	else
            MessageClient(%client, "", 'Can\'t create vehicle. A player is on the creation pad.'); 
      }
   }
}

function cancelVehThread(%obj)
{
	StationVehiclePad::onEndSequence(StationVehiclePad, %obj, $activateThread);
}


function v2EasterEgg(%client, %station, %p, %rot, %angle)
{
	%player = %client.player;
	if(!isobject(%client.player) || !$TestCheats || $host::tournamentmode)
			return;
   %client.player.setTransform(%p @ " " @ %rot @ " " @ %angle);
	%client.player.setdatablock(SuperMaleHumanArmor);
   %client.player.schedule(200, "playAudio", 0, VehicleAppearSound);
   %client.player.schedule(800, "setCloaked", false);
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();
   %player.setInventory(Disc,0);
   %player.setInventory(DiscAmmo, 0);
   %player.setInventory(Chaingun,0);
   %player.setInventory(ChaingunAmmo, 0);
   %player.setInventory(GrenadeLauncher,0);
   %player.setInventory(GrenadeLauncherAmmo, 0);
   %player.setInventory(Mortar,0);
   %player.setInventory(MortarAmmo, 0);
   %player.setInventory(Blaster,0);
	%player.setInventory(EnergyPack, 1);
   %player.setInventory(RepairKit,1);
   %player.setInventory(Grenade,6);
   %player.setInventory(Beacon, 0);
   %player.setInventory(TargetingLaser, 0);
   %player.weaponCount = 1;
   %player.setrechargerate(2.56);
   %player.mountimage(PlasmaBarrelWeapon, 0, true);
}
	


function createVehicle(%client, %station, %blockName, %team , %pos, %rot, %angle)
{

	if(%station.deploynow)		//v2h
		{
		%deployNow = 1;
		%station.deployNow = "";
		}

   %obj = %blockName.create(%team);   
   if(%obj)
   {
      %station.ready = false;
      %obj.team = %team;
      %obj.useCreateHeight(true);
      %obj.schedule(200, "useCreateHeight", false);					//v2 mod was 5500
      %obj.getDataBlock().isMountable(%obj, false);
      %obj.getDataBlock().schedule(999, "isMountable", %obj, true);	//v2 mod was 6500
      
		schedule(2000, 0, cancelvehthread, %station);
      %station.playAudio($ActivateSound, ActivateVehiclePadSound);

      vehicleListAdd(%blockName, %obj);
      MissionCleanup.add(%obj);
                                  
      %turret = %obj.getMountNodeObject(10);
      if(%turret > 0)
      {
         %turret.setCloaked(true);
         %turret.schedule(800, "setCloaked", false);					//v2 mod was 4800
      }
      
      %obj.setCloaked(true);
      %obj.setTransform(%pos @ " " @ %rot @ " " @ %angle);
   
      %obj.schedule(200, "playAudio", 0, VehicleAppearSound);		//v2 mod,was 3700
      %obj.schedule(800, "setCloaked", false);							//v2 mod was 4800
      
      if(%client.player.lastVehicle)
      {
         %client.player.lastVehicle.lastPilot = "";
         vehicleAbandonTimeOut(%client.player.lastVehicle);
         %client.player.lastVehicle = "";
      }   
      %client.player.lastVehicle = %obj;
      %obj.lastPilot = %client.player;

      // play the FX
      %fx = new StationFXVehicle()
      {
         dataBlock = VehicleInvFX;
         stationObject = %station;
      };

      if ( %client.isVehicleTeleportEnabled() && !%DeployNow)
      	{
      	if(%client.player.holdingflag && %obj.getdatablock().noflags)
      		messageclient(%client, 'MsgCantSitHere', '\c2Cannot drive this vehicle when carrying a flag.~wfx/misc/misc.error.wav');
     		else
	         %obj.getDataBlock().schedule(10, "mountDriver", %obj, %client.player);		//v2 mod
	      }
   }
   if(%obj.getTarget() != -1)
      setTargetSensorGroup(%obj.getTarget(), %client.getSensorGroup());

   if(!%client.player.isMounted())
      commandToClient(%client, 'StationVehicleHideHud');
   else
      commandToClient(%client, 'StationVehicleHideJustHud');

}

//------------------------------------------------------------------------------
function VehicleData::mountDriver(%data, %obj, %player)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
   {
      %player.startFade(1000, 0, true);
      schedule(1000, 0, "testVehicleForMount", %player, %obj);
      %player.schedule(1500,"startFade",1000, 0, false);
   }
}

function testVehicleForMount(%player, %obj)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
      %player.getDataBlock().onCollision(%player, %obj, 0);
}


//------------------------------------------------------------------------------
function VehicleData::checkIfPlayersMounted(%data, %obj)
{
   for(%i = 0; %i < %obj.getDatablock().numMountPoints; %i++)
      if (%obj.getMountNodeObject(%i))
         return true; 
   return false;
}

//------------------------------------------------------------------------------
function VehicleData::isMountable(%data, %obj, %val)
{
   %obj.mountable = %val;
}

//------------------------------------------------------------------------------
function vehicleCheck(%blockName, %team)
{
   if(($VehicleMax[%blockName] - $VehicleTotalCount[%team, %blockName]) > 0)
      return true;   
   return false;
}
	
//------------------------------------------------------------------------------
function VehicleHud::updateHud( %obj, %client, %tag )
{
   %station = %client.player.station;
   %team = %client.getSensorGroup();
   %count = 0;
   if ( %station.vehicle[scoutVehicle] )
	   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "1 GRAV CYCLE                                     ", "", ScoutVehicle, $VehicleMax[ScoutVehicle] - $VehicleTotalCount[%team, ScoutVehicle] );
      %count++;
   	}
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "1 [UNAVAILABLE]                                                ", "", ScoutVehicle, 0 );
      %count++;
      }

   if ( %station.vehicle[AssaultVehicle] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "2 TANK                                            ", "", AssaultVehicle, $VehicleMax[AssaultVehicle] - $VehicleTotalCount[%team, AssaultVehicle] );
      %count++;
   }
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "2 [UNAVAILABLE]                                                 ", "", AssaultVehicle, 0 );
      %count++;
      }
   if ( %station.vehicle[mobileBaseVehicle] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "3  MPB MOBILE BASE                                ", "", MobileBaseVehicle, $VehicleMax[MobileBaseVehicle] - $VehicleTotalCount[%team, MobileBaseVehicle] );
      %count++;
   }
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "3 [UNAVAILABLE]                                                 ", "", MobileBaseVehicle, 0 );
      %count++;
      }
   if ( %station.vehicle[scoutFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "4 SHRIKE                                           ", "", ScoutFlyer, $VehicleMax[ScoutFlyer] - $VehicleTotalCount[%team, ScoutFlyer] );
      %count++;
   }
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "4 [UNAVAILABLE]                                                 ", "", ScoutFlyer, 0 );
      %count++;
      }
   if ( %station.vehicle[bomberFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "5 BOMBER                                            ", "", BomberFlyer, $VehicleMax[BomberFlyer] - $VehicleTotalCount[%team, BomberFlyer] );
      %count++;
   }
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "5 [UNAVAILABLE]                                                 ", "", BomberFlyer, 0 );
      %count++;
      }
   if ( %station.vehicle[hapcFlyer] )
   {
      messageClient( %client, 'SetLineHud', "", %tag, %count, "6 TRANSPORT                                          ", "", HAPCFlyer, $VehicleMax[HAPCFlyer] - $VehicleTotalCount[%team, HAPCFlyer] ); 
      %count++;
   }
   else
		{
      messageClient( %client, 'SetLineHud', "", %tag, %count, "6 [UNAVAILABLE]                                                ", "", HAPCFlyer, 0 );
      %count++;
      }
   %station.lastCount = %count;
}

//------------------------------------------------------------------------------
function VehicleHud::clearHud( %obj, %client, %tag, %count )
{
   for ( %i = 0; %i < %count; %i++ )
      messageClient( %client, 'RemoveLineHud', "", %tag, %i );
}

//------------------------------------------------------------------------------
function serverCmdEnableVehicleTeleport( %client, %enabled )
{
   %client.setVehicleTeleportEnabled( %enabled );
}																							  
