///////////////////
//Grappling Hook
///////////////////

datablock AudioProfile(GrapplerrSwitchSound)
{
   filename    = "fx/weapons/generic_switch.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(GrapplerPaintSound)
{
   filename    = "fx/weapons/targetinglaser_paint.wav";
   description = CloseLooping3d;
   preload = true;
};


//--------------------------------------
// Projectile
//--------------------------------------
datablock GrapplerProjectileData(BasicGrappler)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 2000;		//v2
   beamColor           	= "0.1 1 0.1";
								
   startBeamWidth			= 0.005;		//v2
   pulseBeamWidth 	   = 0.005;		//v2
   beamFlareAngle 	   = 5.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;
   dynamicType = $TypeMasks::SensorObjectType;
   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};


//--------------------------------------
// Rifle and item...
//--------------------------------------
datablock ItemData(Grappler)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_targeting.dts";
   image        = TargetingLaserImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a grappling hook";

   computeCRC = true;

};

datablock ShapeBaseImageData(GrapplerImage)
{
   className = WeaponImage;

   shapeFile = "weapon_targeting.dts";
   item = Grappler;
   offset = "0 0 0";

   projectile = BasicGrappler;
   projectileType = GrapplerProjectile;
   deleteLastProjectile = true;

	usesEnergy = true;
	minEnergy = 3;

	firetime = 0;		//v2
	
   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
	stateSound[0]                    = GrapplerSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnAmmo[1]         = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
	stateEnergyDrain[3]              = 3;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
   stateTransitionOnTriggerUp[3]    = "Deconstruction";
   stateTransitionOnNoAmmo[3]       = "Deconstruction";
   stateSound[3]                    = GrapplerPaintSound;

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Ready";

   stateName[5]                     = "Deconstruction";
   stateScript[5]                   = "deconstruct";
   stateTransitionOnTimeout[5]      = "Ready";
};



function GrapplerImage::onFire(%data,%obj,%slot)
{
if (%obj.holdingFlag) return;
	%energy = %obj.getEnergyLevel();
   %muzzlePos = %obj.getMuzzlePoint(%slot);
   %muzzleVec = %obj.getMuzzleVector(%slot);
     %beamtime = 400;

   %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, %data.projectile.maxRifleRange));


   %SearchMask = $TypeMasks::SensorObjectType |
                         $TypeMasks::InteriorObjectType |
                         $TypeMasks::ForceFieldObjectType |
                         $TypeMasks::StaticObjectType |
                         $TypeMasks::MoveableObjectType |
                         $TypeMasks::DamagableItemObjectType |
                         $TypeMasks::TerrainObjectType;

   // did I miss anything? players, vehicles, stations, gens, sensors, turrets
   %hit = ContainerRayCast(%muzzlePos, %endPos, %SearchMask, %obj);
   %noDisplay = true;

   if (%hit !$= "0")
   {
	%clientID = %obj.client;
	if (%obj.client.beamer == 0 && %energy > 15)
		{
			%obj.client.beamer = 1;
        	messageClient(%obj.getOwnerClient(), 'MsgBeamerStatus', '~wfx/weapons/cg_hard3.wav');
			%obj.setEnergyLevel(%energy - 15);
        	beamerOn(%data, %obj, %hit, %slot);
		}
	else
	{
		%obj.client.beamer = 0;
	     if(isObject(%obj.beamproj)) %obj.beamproj.schedule(%beamtime, "delete");
		messageClient(%obj.getOwnerClient(), 'MsgBeamerStatus', '~wfx/weapons/ELF_underwater.wav');
	}

	}
}

function beamerOn(%data, %obj, %hit, %slot)
	{
     %beamtime = 400;
     if(isObject(%obj.beamproj)) %obj.beamproj.schedule(%beamtime, "delete");

	if (%obj.client.beamer != 1)
		return;
			%obj.setHeat(1.0);  //max out the heat signature

   		%hitobj = getWord(%hit, 0);
   		%hitpos = getWord(%hit, 1) @ " " @ getWord(%hit, 2) @ " " @ getWord(%hit, 3);
        %xhit = getword(%hitpos, 0);
        %yhit = getword(%hitpos, 1);
        %zhit = getword(%hitpos, 2);
        %xobj = getword(%obj.position, 0);
        %yobj = getword(%obj.position, 1);
        %zobj = getword(%obj.position, 2);
        %x = %xhit - %xobj;
        %y = %yhit - %yobj;
        %z = %zhit - %zobj;
        %displacement = %x @ " " @ %y @ " " @ %z;
        %x = getword(%displacement, 0);
        %y = getword(%displacement, 1);
        %z = getword(%displacement, 2);
    %distance = mSqrt(%x * %x + %y * %y + %z * %z);
    	%x = %x / %distance;
    	%y = %y / %distance;
    	%z = %z / %distance;
    	%displacement = %x @ " " @ %y @ " " @ %z;
    if (%distance < 5  || %obj.client.beamer == 0)
    {
		%obj.client.beamer = 0;
		messageClient(%obj.getOwnerClient(), 'MsgBeamerStatus', '~wfx/weapons/ELF_underwater.wav');
     if(isObject(%obj.beamproj)) %obj.beamproj.schedule(%beamtime, "delete");
		%velocity = VectorScale(%displacement, 5);
        %obj.setVelocity(%velocity);
		return;
	}
%z = %z + 0.25;
    	%fix = %x @ " " @ %y @ " " @ %z;

    if (%distance < 55)	%velocity = VectorScale(%fix, (%distance * 2));
	else					%velocity = VectorScale(%fix, 110);  //was 500
		        %obj.setVelocity(%velocity);

   %muzzlePos = %obj.getMuzzlePoint(%slot);

//Below is some code I should try
//%VectorBetween = VectorSub(%Position1, %Position2);
//%Length = VectorLen(%VectorBetween);
//%data.Projectile.maxRifleRange = %Length;
// %Projectile = new TargetProjectile()

   %obj.beamproj = new (%data.projectileType)() {
	      dataBlock        = %data.projectile;
	      initialDirection = %displacement;
	      initialPosition  = %muzzlePos;
	      damageFactor     = 0;
	      sourceSlot       = 0;  //%slot
	      fadeTime			= %beamtime;
	   };
   MissionCleanup.add(%obj.beamproj);

		schedule(%beamtime,0,"beamerOn",%data,%obj,%hit,%slot);
	}
